/*
 * GCat's Master System Emulator
 * Copyright (c) 2012 James Perry
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MASTERSYSTEM_H_
#define _MASTERSYSTEM_H_

int MS_startup();
int MS_loadROM(char *filename);
int MS_saveState(char *filename);
int MS_loadState(char *filename);

void MS_getAudioData(unsigned short *audio);

int MS_execute();

int MS_getDebugWord(int idx);
void MS_triggerNMI();
void MS_setJoypadPort1(int val);

unsigned int MS_getBorderColour();
int MS_getScreenMode();

void MS_getScreenPixels(unsigned int *screen);

#endif
