@
@ GCat's Master System Emulator
@ Copyright (c) 2012 James Perry
@
@ This program is free software: you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation, either version 3 of the License, or
@ (at your option) any later version.
@
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@
@ You should have received a copy of the GNU General Public License
@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
@

@
@ IX/IY CB-prefixed instructions
@
ixinsncb:
	@ read displacement byte which is next
	READ_SIGNED_BYTE(r3, r9, r3, r2)
	INC16(r9)
	@ add displacement
	add	r8, r8, r3
	bic	r8, r8, #0xff000000
	bic	r8, r8, #0x00ff0000
	@ read actual op-code byte
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	@ remember no R increment!
	@ lookup and branch to op-code
	ldr	r2,[r0, #68]
	ldr	pc,[r2, r3, lsl #2]
	
	
	.global	ixcbinsn_table
ixcbinsn_table:
	.word	ixcbinsn00, ixcbinsn01, ixcbinsn02, ixcbinsn03
	.word	ixcbinsn04, ixcbinsn05, ixcbinsn06, ixcbinsn07
	.word	ixcbinsn08, ixcbinsn09, ixcbinsn0a, ixcbinsn0b
	.word	ixcbinsn0c, ixcbinsn0d, ixcbinsn0e, ixcbinsn0f
	.word	ixcbinsn10, ixcbinsn11, ixcbinsn12, ixcbinsn13
	.word	ixcbinsn14, ixcbinsn15, ixcbinsn16, ixcbinsn17
	.word	ixcbinsn18, ixcbinsn19, ixcbinsn1a, ixcbinsn1b
	.word	ixcbinsn1c, ixcbinsn1d, ixcbinsn1e, ixcbinsn1f
	.word	ixcbinsn20, ixcbinsn21, ixcbinsn22, ixcbinsn23
	.word	ixcbinsn24, ixcbinsn25, ixcbinsn26, ixcbinsn27
	.word	ixcbinsn28, ixcbinsn29, ixcbinsn2a, ixcbinsn2b
	.word	ixcbinsn2c, ixcbinsn2d, ixcbinsn2e, ixcbinsn2f
	.word	ixcbinsn30, ixcbinsn31, ixcbinsn32, ixcbinsn33
	.word	ixcbinsn34, ixcbinsn35, ixcbinsn36, ixcbinsn37
	.word	ixcbinsn38, ixcbinsn39, ixcbinsn3a, ixcbinsn3b
	.word	ixcbinsn3c, ixcbinsn3d, ixcbinsn3e, ixcbinsn3f

	.word	ixcbinsn40, ixcbinsn41, ixcbinsn42, ixcbinsn43
	.word	ixcbinsn44, ixcbinsn45, ixcbinsn46, ixcbinsn47
	.word	ixcbinsn48, ixcbinsn49, ixcbinsn4a, ixcbinsn4b
	.word	ixcbinsn4c, ixcbinsn4d, ixcbinsn4e, ixcbinsn4f
	.word	ixcbinsn50, ixcbinsn51, ixcbinsn52, ixcbinsn53
	.word	ixcbinsn54, ixcbinsn55, ixcbinsn56, ixcbinsn57
	.word	ixcbinsn58, ixcbinsn59, ixcbinsn5a, ixcbinsn5b
	.word	ixcbinsn5c, ixcbinsn5d, ixcbinsn5e, ixcbinsn5f
	.word	ixcbinsn60, ixcbinsn61, ixcbinsn62, ixcbinsn63
	.word	ixcbinsn64, ixcbinsn65, ixcbinsn66, ixcbinsn67
	.word	ixcbinsn68, ixcbinsn69, ixcbinsn6a, ixcbinsn6b
	.word	ixcbinsn6c, ixcbinsn6d, ixcbinsn6e, ixcbinsn6f
	.word	ixcbinsn70, ixcbinsn71, ixcbinsn72, ixcbinsn73
	.word	ixcbinsn74, ixcbinsn75, ixcbinsn76, ixcbinsn77
	.word	ixcbinsn78, ixcbinsn79, ixcbinsn7a, ixcbinsn7b
	.word	ixcbinsn7c, ixcbinsn7d, ixcbinsn7e, ixcbinsn7f

	.word	ixcbinsn80, ixcbinsn81, ixcbinsn82, ixcbinsn83
	.word	ixcbinsn84, ixcbinsn85, ixcbinsn86, ixcbinsn87
	.word	ixcbinsn88, ixcbinsn89, ixcbinsn8a, ixcbinsn8b
	.word	ixcbinsn8c, ixcbinsn8d, ixcbinsn8e, ixcbinsn8f
	.word	ixcbinsn90, ixcbinsn91, ixcbinsn92, ixcbinsn93
	.word	ixcbinsn94, ixcbinsn95, ixcbinsn96, ixcbinsn97
	.word	ixcbinsn98, ixcbinsn99, ixcbinsn9a, ixcbinsn9b
	.word	ixcbinsn9c, ixcbinsn9d, ixcbinsn9e, ixcbinsn9f
	.word	ixcbinsna0, ixcbinsna1, ixcbinsna2, ixcbinsna3
	.word	ixcbinsna4, ixcbinsna5, ixcbinsna6, ixcbinsna7
	.word	ixcbinsna8, ixcbinsna9, ixcbinsnaa, ixcbinsnab
	.word	ixcbinsnac, ixcbinsnad, ixcbinsnae, ixcbinsnaf
	.word	ixcbinsnb0, ixcbinsnb1, ixcbinsnb2, ixcbinsnb3
	.word	ixcbinsnb4, ixcbinsnb5, ixcbinsnb6, ixcbinsnb7
	.word	ixcbinsnb8, ixcbinsnb9, ixcbinsnba, ixcbinsnbb
	.word	ixcbinsnbc, ixcbinsnbd, ixcbinsnbe, ixcbinsnbf

	.word	ixcbinsnc0, ixcbinsnc1, ixcbinsnc2, ixcbinsnc3
	.word	ixcbinsnc4, ixcbinsnc5, ixcbinsnc6, ixcbinsnc7
	.word	ixcbinsnc8, ixcbinsnc9, ixcbinsnca, ixcbinsncb
	.word	ixcbinsncc, ixcbinsncd, ixcbinsnce, ixcbinsncf
	.word	ixcbinsnd0, ixcbinsnd1, ixcbinsnd2, ixcbinsnd3
	.word	ixcbinsnd4, ixcbinsnd5, ixcbinsnd6, ixcbinsnd7
	.word	ixcbinsnd8, ixcbinsnd9, ixcbinsnda, ixcbinsndb
	.word	ixcbinsndc, ixcbinsndd, ixcbinsnde, ixcbinsndf
	.word	ixcbinsne0, ixcbinsne1, ixcbinsne2, ixcbinsne3
	.word	ixcbinsne4, ixcbinsne5, ixcbinsne6, ixcbinsne7
	.word	ixcbinsne8, ixcbinsne9, ixcbinsnea, ixcbinsneb
	.word	ixcbinsnec, ixcbinsned, ixcbinsnee, ixcbinsnef
	.word	ixcbinsnf0, ixcbinsnf1, ixcbinsnf2, ixcbinsnf3
	.word	ixcbinsnf4, ixcbinsnf5, ixcbinsnf6, ixcbinsnf7
	.word	ixcbinsnf8, ixcbinsnf9, ixcbinsnfa, ixcbinsnfb
	.word	ixcbinsnfc, ixcbinsnfd, ixcbinsnfe, ixcbinsnff

	@ rlc (ix+d)
ixcbinsn00:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn01:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn02:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn03:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn04:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn05:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn06:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn07:
	READ_BYTE(r12, r8, r3, r2)
	RLC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ rrc (ix+d)
ixcbinsn08:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn09:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn0a:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn0b:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn0c:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn0d:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn0e:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn0f:
	READ_BYTE(r12, r8, r3, r2)
	RRC8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ rl (ix+d)
ixcbinsn10:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn11:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn12:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn13:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn14:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn15:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn16:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn17:
	READ_BYTE(r12, r8, r3, r2)
	RL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ rr (ix+d)
ixcbinsn18:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn19:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn1a:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn1b:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn1c:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn1d:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn1e:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn1f:
	READ_BYTE(r12, r8, r3, r2)
	RR8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


	@ sla (ix+d)
ixcbinsn20:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn21:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn22:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn23:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn24:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn25:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn26:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn27:
	READ_BYTE(r12, r8, r3, r2)
	SLA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ sra (ix+d)
ixcbinsn28:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn29:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn2a:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn2b:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn2c:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn2d:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn2e:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn2f:
	READ_BYTE(r12, r8, r3, r2)
	SRA8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ sll (ix+d)
ixcbinsn30:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn31:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn32:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn33:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn34:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn35:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn36:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn37:
	READ_BYTE(r12, r8, r3, r2)
	SLL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ srl (ix+d)
ixcbinsn38:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn39:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn3a:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn3b:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn3c:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn3d:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn3e:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn3f:
	READ_BYTE(r12, r8, r3, r2)
	SRL8_LO(r12, r3, r2)
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	
	@ bit b,(ix+d)
ixcbinsn40:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn41:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn42:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn43:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn44:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn45:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn46:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	END_INSN(#20)
ixcbinsn47:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #1)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)

ixcbinsn48:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn49:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn4a:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn4b:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn4c:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn4d:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn4e:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	END_INSN(#20)
ixcbinsn4f:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)


ixcbinsn50:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn51:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn52:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn53:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn54:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn55:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn56:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	END_INSN(#20)
ixcbinsn57:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #4)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)

ixcbinsn58:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn59:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn5a:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn5b:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn5c:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn5d:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn5e:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	END_INSN(#20)
ixcbinsn5f:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #8)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)


ixcbinsn60:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn61:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn62:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn63:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn64:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn65:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn66:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	END_INSN(#20)
ixcbinsn67:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x10)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)

ixcbinsn68:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn69:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn6a:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn6b:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn6c:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn6d:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn6e:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	END_INSN(#20)
ixcbinsn6f:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x20)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)


ixcbinsn70:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn71:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn72:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn73:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn74:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn75:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn76:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	END_INSN(#20)
ixcbinsn77:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST(r12, #0x40)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)

ixcbinsn78:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#20)
ixcbinsn79:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#20)
ixcbinsn7a:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#20)
ixcbinsn7b:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#20)
ixcbinsn7c:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#20)
ixcbinsn7d:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#20)
ixcbinsn7e:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	END_INSN(#20)
ixcbinsn7f:
	READ_BYTE(r12, r8, r3, r2)
	BIT_TEST7(r12, #0x80)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#20)

	@ res b,(ix+d)
ixcbinsn80:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn81:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn82:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn83:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn84:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn85:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn86:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn87:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsn88:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn89:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn8a:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn8b:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn8c:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn8d:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn8e:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn8f:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsn90:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn91:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn92:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn93:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn94:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn95:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn96:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn97:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsn98:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsn99:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsn9a:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsn9b:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsn9c:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsn9d:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsn9e:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsn9f:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsna0:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsna1:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsna2:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsna3:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsna4:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsna5:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsna6:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsna7:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsna8:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsna9:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnaa:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnab:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnac:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnad:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnae:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnaf:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsnb0:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnb1:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnb2:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnb3:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnb4:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnb5:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnb6:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnb7:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsnb8:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnb9:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnba:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnbb:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnbc:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnbd:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnbe:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnbf:
	READ_BYTE(r12, r8, r3, r2)
	bic	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

	@ set b,(ix+d)
ixcbinsnc0:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnc1:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnc2:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnc3:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnc4:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnc5:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnc6:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnc7:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #1
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsnc8:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnc9:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnca:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsncb:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsncc:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsncd:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnce:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsncf:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #2
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsnd0:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnd1:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnd2:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnd3:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnd4:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnd5:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnd6:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnd7:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #4
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsnd8:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnd9:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnda:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsndb:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsndc:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsndd:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnde:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsndf:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #8
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsne0:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsne1:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsne2:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsne3:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsne4:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsne5:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsne6:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsne7:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x10
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsne8:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsne9:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnea:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsneb:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnec:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsned:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnee:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnef:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x20
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)


ixcbinsnf0:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnf1:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnf2:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnf3:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnf4:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnf5:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnf6:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnf7:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x40
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

ixcbinsnf8:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff
	orr	r5, r5, r12, lsl #8
	END_INSN(#23)
ixcbinsnf9:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r5, r5, #0xff00
	orr	r5, r5, r12
	END_INSN(#23)
ixcbinsnfa:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff
	orr	r6, r6, r12, lsl #8
	END_INSN(#23)
ixcbinsnfb:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r6, r6, #0xff00
	orr	r6, r6, r12
	END_INSN(#23)
ixcbinsnfc:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff
	orr	r7, r7, r12, lsl #8
	END_INSN(#23)
ixcbinsnfd:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	and	r7, r7, #0xff00
	orr	r7, r7, r12
	END_INSN(#23)
ixcbinsnfe:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	END_INSN(#23)
ixcbinsnff:
	READ_BYTE(r12, r8, r3, r2)
	orr	r12, r12, #0x80
	WRITE_BYTE(r12, r8, r3, r2)
	bic	r4, r4, #0xff
	orr	r4, r4, r12
	END_INSN(#23)

